//------------------------------------------------------------------
#property copyright "none"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_style2 STYLE_DOT
#property indicator_level1 23.6
#property indicator_level2 76.4
#property indicator_level3 50
#property indicator_levelcolor Gray
#property indicator_minimum 0
#property indicator_maximum 100

extern string TimeFrame      = "Current time frame";
extern int    Period_MIN     = 15;
extern int    Step           = 10;
extern int    Slowing        = 20;
extern double T3Hot          = 0.7;
extern bool   T3Original     = false;
extern int    Signal         = 20;
extern double SignalHot      = 0.7;
extern int    SignalOriginal = false;
extern int    Price          = PRICE_CLOSE; 
extern int    Shift          = 0;

double TrendBuffer[];
double LoBuffer[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

double Period1,Period2,Period3,Period4,Period5;
int init()
{
    SetIndexBuffer(0, TrendBuffer); SetIndexLabel( 0, "Main");
    SetIndexBuffer(1, LoBuffer);    SetIndexLabel( 1, "Signal");
    IndicatorShortName(" T3 Stochsastic mean (" + Period_MIN + ", "+ Step + ", "+ Slowing +")");
      Period1 = Period_MIN;
      Period2 = Period_MIN + Step;
      Period3 = Period_MIN + Step * 2;
      Period4 = Period_MIN + Step * 3;
      Period5 = Period_MIN + Step * 4;
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
         calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         SetIndexShift(0,Shift*timeFrame/Period());
         SetIndexShift(1,Shift*timeFrame/Period());
   IndicatorShortName(timeFrameToString(timeFrame)+" ST T3");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { TrendBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int shift = limit; shift >= 0 ; shift--)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,shift);
         double stok1 = iT3Stoch(price,Period1,Slowing,T3Hot,T3Original,shift,0)*0.20;
         double stok2 = iT3Stoch(price,Period2,Slowing,T3Hot,T3Original,shift,1)*0.20;
         double stok3 = iT3Stoch(price,Period3,Slowing,T3Hot,T3Original,shift,2)*0.20;
         double stok4 = iT3Stoch(price,Period4,Slowing,T3Hot,T3Original,shift,3)*0.20;
         double stok5 = iT3Stoch(price,Period5,Slowing,T3Hot,T3Original,shift,4)*0.20;
         double mov   = stok1 + stok2 + stok3 + stok4 + stok5;
            TrendBuffer[shift] = mov;
            LoBuffer[shift]    = MathMax(MathMin(iT3(mov,Signal,SignalHot,SignalOriginal,Bars-shift-1,5),100),0);
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (int i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);               
          TrendBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period_MIN,Step,Slowing,T3Hot,T3Original,Signal,SignalHot,SignalOriginal,Price,0,0,y);
          LoBuffer[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period_MIN,Step,Slowing,T3Hot,T3Original,Signal,SignalHot,SignalOriginal,Price,0,1,y);
   }
   return(0);         
}
	    
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][5];
double iT3Stoch(double price, int period, int slowing, double t3Hot, double t3Original, int i, int instanceNo=0)
{
   if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars); i=Bars-i-1;
   
   //
   //
   //
   //
   //
   
   work[i][instanceNo] = price;
      double sto = 0;
      double min = price;
      double max = price;
         for (int k=1; k<period && (i-k)>=0; k++) 
            {
               min = MathMin(min,work[i-k][instanceNo]);
               max = MathMax(max,work[i-k][instanceNo]);
            }
            if (min!=max)
                     sto = MathMax(MathMin(iT3(100.0*(price-min)/(max-min),slowing,t3Hot,t3Original,i,instanceNo),100),0);
               else  sto = MathMax(MathMin(iT3(50.0                       ,slowing,t3Hot,t3Original,i,instanceNo),100),0);
   return(sto);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][36];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int r, int instanceNo=0)
{
   if (ArrayRange(workT3,0) !=Bars)                 ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   if (r<2)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}